/*
   ExcelReadTest.prg
   A sample dBL program from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2007. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 22
   open a spreadsheet and load data within a range of cells
   into an array 
*/

try
   oExcel = new OLEAutoClient( "excel.application" )
catch( Exception E )
   ? "Cannot open Excel" 
   return
endtry
oExcel.DisplayAlerts=false
try
   oExcel.workbooks.open(set("dire")+"\TestSpreadsheet.xls")
catch( Exception E )
   ? e.message
   return
endtry

// Get Start Row and Column
cStartRange = "A1"
cEndRange = "E7"
oExcel.Range( cStartRange ).Select()
nStartCol = oExcel.activecell.column
nStartRow = oExcel.activeCell.row
oExcel.Range( cEndRange ).Select()
nEndCol = oExcel.activecell.column
nEndRow = oExcel.activeCell.row
// need to know the number of rows ...
nEndRow = ( nEndRow - nStartRow + 1 )

? "End Row: "+ nEndRow
? "End Col: "+ nEndCol
// Load the array:
aExcel = new array( 7, 5 ) // 7 rows, 5 columns
for i = nStartRow to nEndRow
   for j = nStartCol to nEndCol
       // 64+1 = 65 = "A"
       cCell = chr(j+64)+ltrim(str(i))
       try
          aExcel[ i, j ] = oExcel.Range( cCell ).value
       catch( exception e )
          ? e.message
          exit
       endtry
   next
next

// display the array (simply, not real pretty):
for i = 1 to 7 // rows
    ? "Row: "+I
    for j = 1 to 5 // columns
        ?? aExcel[ i, j ]
    next
next

// cleanup
release object oExcel
oExcel = ""
release oExcel