/*
   NavigateByMaster.prg
   A sample dBL program from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2007. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 7 
   Example of the sequence displayed when using navigateByMaster in the
   child rowset.
*/

// navigateByMaster example:
clear
// Parent table:
qParent = new query()
qParent.sql := "select * from ParentTest"
qParent.active := true
// short references:
rParent = qParent.rowset
fParent = rParent.fields

// Child table:
qChild = new query()
qChild.sql := "select * from ChildTest"
qChild.active := true
// short references:
rChild = qChild.rowset
fChild = rChild.fields
// set the index:
rChild.indexName := "LinkField"
// set the masterRowset/masterFields:
rChild.masterRowset := rParent
rChild.masterFields := "LINKFIELD"
// the navigateByMaster property is not set, 
// and is the default: false
? "navigateByMaster = false"

// navigate through the master table, and show the linked data:
rParent.first()
do while not rParent.endOfSet
   ? fParent["ParentData"].value+" "+;
     fChild["ChildData"].value
   rParent.next()
enddo

// now set the navigateByMaster to true:
rChild.navigateByMaster := true
?
? "navigateByMaster = true"
// navigate through the master table, and show the linked data:
rParent.first()
do while not rParent.endOfSet
   ? fParent["ParentData"].value+" "+;
     fChild["ChildData"].value
   rParent.next()
enddo



