/*
   MyPushbuttons.cc
   A sample dBL custom class file from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2007. 
   Permission granted for use as a learning tool for dBASE Plus.

   Some basic custom pushbuttons for use in different parts of the book.
*/

class FirstButton(oParent) of MyPushbutton(oParent) from ":MyFormControls:MyFormControls.cc" custom
   this.text := "First"
   function onClick
      form.rowset.first()
   return
endclass

class LastButton(oParent) of MyPushbutton(oParent) from ":MyFormControls:MyFormControls.cc" custom
   this.text := "Last"
   function onClick
      form.rowset.last()
   return
endclass

class NextButton(oParent) of MyPushbutton(oParent) from ":MyFormControls:MyFormControls.cc" custom
   this.text := "Next"
   function onClick
      if ( not form.rowset.next() )
         form.rowset.last()
         msgbox( "At end of rowset", "Can't Navigate", 64 )
      endif
   return
endclass

class PreviousButton(oParent) of MyPushbutton(oParent) from ":MyFormControls:MyFormControls.cc" custom
   this.text := "Previous"
   function onClick
      if ( not form.rowset.next(-1) )
         form.rowset.last()
         msgbox( "At end of rowset", "Can't Navigate", 64 )
      endif
   return
endclass

class AddRowButton(oParent) of MyPushbutton(oParent) from ":MyFormControls:MyFormControls.cc" custom
   this.text := "Add Row"
   function onClick
      form.rowset.beginAppend()
   return
endclass

class EditRowButton(oParent) of MyPushbutton(oParent) from ":MyFormControls:MyFormControls.cc" custom
   this.text := "Edit Row"
   function onClick
      form.rowset.beginEdit()
   return
endclass

class DeleteRowButton(oParent) of MyPushbutton(oParent) from ":MyFormControls:MyFormControls.cc" custom
   this.text := "Delete Row"
   function onClick
      if msgbox( "Delete this row?", "Delete Row?", 36 ) == 6
         form.rowset.delete()
      endif
   return
endclass

class SaveRowButton(oParent) of MyPushbutton(oParent) from ":MyFormControls:MyFormControls.cc" custom
   this.text := "Save Row"
   function onClick
      form.rowset.save()
   return
endclass

class AbandonRowButton(oParent) of MyPushbutton(oParent) from ":MyFormControls:MyFormControls.cc" custom
   this.text := "Abandon Row"
   function onClick
      if msgbox( "Abandon changes to this row?", "Abandon changes?", 36 ) == 6
         form.rowset.abandon()
      endif
   return
endclass

class CloseButton(oParent) of MyPushbutton(oParent) from ":MyFormControls:MyFormControls.cc" custom
   this.text := "Close"
   function onClick
      form.close()
   return
endclass

class MyRowState(oParent) of Entryfield(oParent) custom
   this.value := "State"
   this.borderStyle := 1 // Raised
   this.colorNormal := "maroon/BtnFace"
   this.fontBold    := true
   this.fontItalic  := true
   this.when        := {|| false }
   function onOpen
      // if we haven't already defined the calc field
      if type('form.rowset.fields["Rowstate"]') # "O"
         // do it here
         local f
         f = new field()        // create it
         f.states = new array() // build an array with the 
                                // possible states
         f.states.add("Closed")
         f.states.add("Browse")
         f.states.add("Edit")
         f.states.add("Append")
         f.states.add("Filter")
         f.states.add("Locate")
         f.fieldName      := "Rowstate"
         f.beforegetvalue := ;
	        {;return this.states[ this.parent.parent.state + 1 ]}
         form.rowset.fields.add( f )
      endif
      this.datalink = form.rowset.fields["Rowstate"]
   return
endclass

class MYSPEEDBAR(parentObj) of CONTAINER(parentObj) custom
   with (this)
      left = 79.0
      top = 53.0
      width = 113.0
      height = 248.0
      metric = 6	// Pixels
   endwith

   this.FIRSTBUTTON1 = new FIRSTBUTTON(this)
   with (this.FIRSTBUTTON1)
      height = 24.0
      left = 0.0
      top = 0.0
      width = 107.0
      pageno = 0
      speedBar = true
   endwith

   this.PREVIOUSBUTTON1 = new PREVIOUSBUTTON(this)
   with (this.PREVIOUSBUTTON1)
      height = 24.0
      left = 0.0
      top = 23.0
      width = 107.0
      pageno = 0
      speedBar = true
   endwith

   this.NEXTBUTTON1 = new NEXTBUTTON(this)
   with (this.NEXTBUTTON1)
      height = 24.0
      left = 0.0
      top = 46.0
      width = 107.0
      pageno = 0
      speedBar = true
   endwith

   this.LASTBUTTON1 = new LASTBUTTON(this)
   with (this.LASTBUTTON1)
      height = 24.0
      left = 0.0
      top = 69.0
      width = 107.0
      pageno = 0
      speedBar = true
   endwith

   this.ADDROWBUTTON1 = new ADDROWBUTTON(this)
   with (this.ADDROWBUTTON1)
      height = 24.0
      left = 0.0
      top = 98.0
      width = 107.0
      pageno = 0
      speedBar = true
   endwith

   this.EDITROWBUTTON1 = new EDITROWBUTTON(this)
   with (this.EDITROWBUTTON1)
      height = 24.0
      left = 0.0
      top = 121.0
      width = 107.0
      pageno = 0
      speedBar = true
   endwith

   this.SAVEROWBUTTON1 = new SAVEROWBUTTON(this)
   with (this.SAVEROWBUTTON1)
      height = 24.0
      left = 0.0
      top = 144.0
      width = 107.0
      pageno = 0
      speedBar = true
   endwith

   this.ABANDONROWBUTTON1 = new ABANDONROWBUTTON(this)
   with (this.ABANDONROWBUTTON1)
      height = 24.0
      left = 0.0
      top = 167.0
      width = 107.0
      pageno = 0
      speedBar = true
   endwith

   this.DELETEROWBUTTON1 = new DELETEROWBUTTON(this)
   with (this.DELETEROWBUTTON1)
      height = 24.0
      left = 0.0
      top = 190.0
      width = 107.0
      pageno = 0
      speedBar = true
   endwith

   this.CLOSEBUTTON1 = new CLOSEBUTTON(this)
   with (this.CLOSEBUTTON1)
      height = 24.0
      left = 0.0
      top = 218.0
      width = 107.0
      pageno = 0
      speedBar = true
   endwith

endclass
